<?php
////////////////////////////////////////////////////////////////////////
// Breeze Website Builder
// Copyright Silver Dolphin Solutions, LLC, Edward Lemmers, P.E.
// For licensing, see license.txt.
// Revised: 6/15/2007
// Fixed bug of missing calendar flag.
// Revised: 8/13/2008	ELL
// Added force page names to lower case if that option is selected.
// Revised: 8/28/2009	ELL
// Changed from adding HTML head code to page template to setting up with new head content so user could possibly modify it in head content editor.
// Revised: 9/27/2010 ELL
// Added mode follow-thru such that returning to main menu after editing pages, border areas, or creating pages brings up the same mode in the main menu.
// Revised: 10/12/2010	ELL
// Changed timestamping of `revised` field due to change from VARCHAR to DATETIME in table structure.
// Revised: 11/9/2010	ELL
// Fixed looming bug where sort of head names would keep finding head9 and last head.  (This fix is similar to that done for adding border areas.)
// Also fixed bug of head not getting incremented to head1.  (It worked for head1 to head2, etc, but somehow left out default case.
// Revised: 11/13/2010	ELL
// Added flag to signify first entering editor.
// Revised: 1/12/2/12	ELL
// Added saving to page_data_draft table to accomodate new upgrade for save to draft mode.
// Added default stirng for body HTML.  It has been noticed that the tew CKEditor won't allow typing very easily without content, so we add starter text.
// Revised: 2/7/2012	ELL
// Added table prefix handling.  Added reference to user files folder constant.
// Revised: 4/26/2012	ELL
// Added special-case checking of existence of index.php at webroot level with website setup to run web pages at webroot.  This automatically deletes
// stock forwarded so index.php home page can be created.
// Revised: 10/11/2012	ELL
// Revamped handlng of plugins to include creation of class and css tables as well as deployment of DB tables and button for backend console.
// Revised: 5/10/2013	ELL
// Added handing of plugin code for new header and footer areas.
// Revised: 12/1/2013	ELL
// Modifed for compatibility with BWB version 5.0.
// Revised: 12/13/2013	ELL
// Added refresh of main menu to update buttons and set to last selections.
// Revised: 3/6/2014	ELL
// Fixed bug with plugins creating addtional head1, header1 and footer1 records whenever a user friendly named area was already created.  i.e. head_home
// This also automatically creates user-friendly speceal areas names based on the page name you just created.
// Revised: 4/3/2014	ELL
// Revamped plugin insertion to look for comments that may be left in such that plugins may be installed on existing pages.  Also added hooks for adding
// plugin code to top, bottom, left and right areas for maximum flexibility.
// Revised: 6/16/2014	ELL
// Added storing of plugin ID's into page data to facilitate content sensitive help for relevant plugins in page editor.
// Revised: 10/16/2014	ELL
// Added setting of disable_site_styles for HTML message page plugins.
// ADded copying of use_table_structure and use_table_structure_mobile flages from selected options to page data for modal switching of use of page table structure
// when page is viewed.
// Revised: 1/10/2015	ELL
// Fixed bug with single quotes in plugin HTML doubling up in border areas and content.
// Revised: 5/1/2015	ELL
// Converted from inline RunSQL function to included library RunSQL function.
//

include ("check_session.php");
		
$page_name = $_POST['createPage'];
$plugin = $_POST['plugin'];
$template_name = $_POST['template_name'];
$mode = $_REQUEST['mode'];

include("lib/run_sql.php");

////////////////////////////////////////////////////////////////////////////////////////////////
function copy_table_structure($table, $table_prefix, $dbh, $database)
{
	$query = "SELECT COUNT(*) FROM information_schema.tables WHERE table_schema = '" . $database . "' AND table_name = '" . $table_prefix . $table . "'";
	$result = $dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$table_count = $row['COUNT(*)'];
	if ($table_count < 1)
	{
		// Must be a missing menu table, find suffix.
		if (strpos($table, "_classes") > 0)
			$source_table = $table_prefix . "site_classes";
		else
			$source_table = $table_prefix . "site_css";
		$query = "CREATE TABLE IF NOT EXISTS " . $table_prefix . $table . " SELECT * FROM " . $source_table;
		$cnt = $dbh->exec($query);
		
		$query = " ALTER TABLE `" . $table_prefix . $table . "` ADD PRIMARY KEY (`class`)";
		$cnt = $dbh->exec($query);
	}
	
	$query = "TRUNCATE TABLE `" . $table_prefix . $table . "`";
	$cnt = $dbh->exec($query);
		
	return 1;
}

	if ($page_name == "")
	{
		echo "Oops! You forgot to enter a page name.  Click <a href=\"create_page_select.php\" title=\"here\">here</a> and enter a page name.";
		exit;
	}
	
	//Remove Unix incompatible characters.
	$page_name = preg_replace("/(?:\s|&nbsp;)+/", "_", $page_name, -1);
	$page_name = preg_replace("/[^A-Za-z0-9_.-]/", "", $page_name, -1);
	$query = "SELECT `option_value` FROM `" . BWB_TABLE_PREFIX . "options_selected` WHERE `option_name`='ForcePageNameToLowerCase'";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$ForcePageNameToLowerCase = $row["option_value"];
	if ($ForcePageNameToLowerCase == 1)
		$page_name = strtolower($page_name);
	
	$page_name = addslashes($page_name);
	
	// Get default use of table structure from selected options.
	$query = "SELECT `option_value` FROM `" . BWB_TABLE_PREFIX . "options_selected` WHERE `option_name`='UseTableStructure'";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$UseTableStructure = $row["option_value"];
	$query = "SELECT `option_value` FROM `" . BWB_TABLE_PREFIX . "options_selected` WHERE `option_name`='UseTableStructureMobile'";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$UseTableStructureMobile = $row["option_value"];
	
	//First check to see if file is alrready in database.
	$query = "SELECT `page_name` FROM `" . BWB_TABLE_PREFIX . "page_data` WHERE `page_name`='$page_name'";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$page_name_retrieved = $row["page_name"];
	if ($page_name_retrieved)
	{
		echo "$file_name already exists in database.  Click <a href=\"create_page_select.php\" title=\"here\">here</a> to enter a different page name.";
		exit;
	}
	
	//Test to see if file already exists.
	$document_root = $_SERVER['DOCUMENT_ROOT'];
	if (BWB_BASE_DIR == '')
		$file_name = $document_root . "/" . BWB_WEBPAGE_DIR . "/" . $page_name . ".php";
	else
		$file_name = $document_root . "/" . BWB_BASE_DIR . "/" . BWB_WEBPAGE_DIR . "/" . $page_name . ".php";
//	echo "File Name: $file_name<br>";
	if (file_exists($file_name))
	{
		if ((BWB_BASE_DIR == '') && (BWB_WEBPAGE_DIR == '') && ($page_name == "index"))	// Special case, getting rid of stock forwarder to /userfiles/file/
			unlink($file_name);
		else
		{
			echo "$file_name already exists.  Click <a href=\"create_page_select.php\" title=\"here\">here</a> to enter a different page name.";
			exit;
		}
	}
	
	// If plugin code selected, then get plugin code snippet.
	if ((!isset($plugin)) || ($plugin == ""))
		$plugin = "-not selected-";
		
	if ($plugin != "-not selected-")
	{
		$query = "SELECT * FROM `" . BWB_TABLE_PREFIX . "plugins` WHERE `id` = $plugin";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$plugin_id = $row["id"];
		$head_code = $row["head_code"];
		$head_html = $row["head_html"];
		$header_code = $row["header_code"];
		$header_html = $row["header_html"];
		$top_code = $row["top_code"];
		$top_html = $row["top_html"];
		$left_code = $row["left_code"];
		$left_html = $row["left_html"];
		$content_code = $row["content_code"];
		$content_html = $row["content_html"];
		$right_code = $row["right_code"];
		$right_html = $row["right_html"];
		$bottom_code = $row["bottom_code"];
		$bottom_html = $row["bottom_html"];
		$footer_code = $row["footer_code"];
		$footer_html = $row["footer_html"];
		$style_sheet = $row["style_sheet"];
		$style_sheet_description = $row["style_sheet_description"];
		$class_sql = $row["class_sql"];
		$css_sql = $row["css_sql"];
		$plugin_sql = $row["plugin_sql"];
		$deployed = $row["deployed"];
		$disable_site_styles = $row["disable_site_styles"];
		// Check template compatibility with plugin.
		if (strpos($template_name, "top_bottom_left_right") < 0)
		{
			if ((isset($top_code) && ($top_code != "")) || (isset($top_html) && ($top_html != "")))
				$need_top = true;
			if ((isset($left_code) && ($left_code != "")) || (isset($left_html) && ($left_html != "")))
				$need_left = true;
			if ((isset($right_code) && ($right_code != "")) || (isset($right_html) && ($right_html != "")))
				$need_right = true;
			if ((isset($bottom_code) && ($bottom_code != "")) || (isset($bottom_html) && ($bottom_html != "")))
				$need_bottom = true;
				
			if ($need_top && $need_left && $need_right && $need_bottom)
				$template_name = "top_bottom_left_right";
			elseif ($need_top && $need_left && $need_right && !$need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "left") < 0) || (strpos($template_name, "right") < 0)))
				$template_name = "top_left_right";
			elseif ($need_top && $need_left && !$need_right && $need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "left") < 0) || (strpos($template_name, "bottom") < 0)))
				$template_name = "top_bottom_left";
			elseif ($need_top && !$need_left && $need_right && $need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "right") < 0) || (strpos($template_name, "right") < 0)))
				$template_name = "top_bottom_left_right";
			elseif (!$need_top && $need_left && $need_right && $need_bottom && ((strpos($template_name, "bottom") < 0) || (strpos($template_name, "left") < 0) || (strpos($template_name, "right") < 0)))
				$template_name = "top_bottom_left_right";
			elseif ($need_top && $need_left && !$need_right && !$need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "left") < 0)))
			{
				if ($template_name == "top_bottom")
					$template_name = "top_bottom_left";
				else
					$template_name = "top_left";
			}
			elseif ($need_top && !$need_left && !$need_right && $need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "bottom") < 0)))
			{
				if ($template_name == "top_left")
					$template_name = "top_bottom_left";
				else
					$template_name = "top_bottom";
			}
			elseif (!$need_top && !$need_left && $need_right && $need_bottom && ((strpos($template_name, "right") < 0) || (strpos($template_name, "bottom") < 0)))
				$template_name = "top_bottom_left_right";
			elseif (!$need_top && $need_left && $need_right && !$need_bottom && ((strpos($template_name, "right") < 0) || (strpos($template_name, "left") < 0)))
				$template_name = "top_bottom_left_right";
			elseif (!$need_top && $need_left && !$need_right && $need_bottom && ((strpos($template_name, "left") < 0) || (strpos($template_name, "bottom") < 0)))
				$template_name = "top_bottom_left";
			elseif ($need_top && !$need_left && $need_right && !$need_bottom && ((strpos($template_name, "top") < 0) || (strpos($template_name, "right") < 0)))
				$template_name = "top_bottom_left";
			elseif ($need_top && !$need_left && !$need_right && !$need_bottom && (strpos($template_name, "top") < 0))
			{
				if ($template_name == "basic")
					$template_name = "top";
				else
					$template_name = "top_left";
			}
			elseif (!$need_top && $need_left && !$need_right && !$need_bottom && (strpos($template_name, "left") < 0))
			{
				if ($template_name == "basic")
					$template_name = "left";
				elseif ($template_name == "top_bottom")
					$template_name = "top_bottom_left";
				elseif ($template_name == "top")
					$template_name = "top_left";
			}
			elseif (!$need_top && !$need_left && $need_right && !$need_bottom && (strpos($template_name, "right") < 0))
			{
				if ($template_name != "top_bottom")
					$template_name = "top_left_right";
				else
					$template_name = "top_bottom_left_right";
			}
			elseif (!$need_top && !$need_left && !$need_right && $need_bottom && (strpos($template_name, "bottom") < 0))
			{
				if (($template_name == "top") || ($template_name == "basic"))
					$template_name = "top_bottom";
				else
					$template_name = "top_bottom_left";
			}
		}
	}
	else
	{
		$content_html = "\n<p>Enter your content here.</p>\n";
		$plugin_id = "";
	}
	
	//Add page name to database.
	$today = date("Y-m-d H:i:s");
	$page_content = addslashes(stripslashes($content_html));
	$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data SET page_name='$page_name', page_content='$page_content', revised='$today', plugins='$plugin_id', disable_site_styles='$disable_site_styles', use_table_structure='$UseTableStructure', use_table_structure_mobile='$UseTableStructureMobile'";
//	echo $query;
	$cnt = $bwb_dbh->exec($query);

// Copy page data to draft table.
	$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_draft SET page_name='$page_name', page_content='$page_content', revised='$today', `source`=0";
//	echo $query;
	$cnt = $bwb_dbh->exec($query);

	//Get template from database.
	$query = "SELECT `page_template` FROM `" . BWB_TABLE_PREFIX . "template` WHERE `template_name` = '$template_name'";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$page_template = $row["page_template"];
	
	//Insert page name into template.
	$zzz_found = false;
	if ($page_name == "zzz")	{
		$page_template = str_replace("xxx", "-ZZZ-", $page_template);
		$zzz_found = true;
	}
	else
		$page_template = str_replace("xxx", $page_name, $page_template);
	
	//Get meta-tags template from database.
	$query = "SELECT `meta_tags_template` FROM `" . BWB_TABLE_PREFIX . "meta_tags_template`";
	$result = $bwb_dbh->query($query);
	$row = $result->fetch(PDO::FETCH_ASSOC);
	$meta_tags_template = $row["meta_tags_template"];
	
	//Insert page name into meta-tags template.
	$meta_tags_template = str_replace("xxx", $page_name, $meta_tags_template);
	
	//Insert meta-tags template into page template.
	$page_template = str_replace("zzz", $meta_tags_template, $page_template);
	
	if ($zzz_found === true)
		$page_template = str_replace("-ZZZ-", $page_name, $page_template);
		
	//If plugin is selected, then insert head code snippet after <!--head_code--> comment.
	if (($plugin != "-not selected-") && ($head_code != ""))
	{
		$page_temp_arr = explode("<!--head_code-->", $page_template, 2);
		$page_template = $page_temp_arr[0] . $head_code . "\n\n<!--head_code-->\n" . $page_temp_arr[1];
		unset($page_temp_arr);
	}
	
	//If plugin is selected, then insert content code snippet after <!--content_code--> comment.
	if (($plugin != "-not selected-") && ($content_code != ""))
	{
		$page_temp_arr = explode("<!--content_code-->", $page_template, 2);
		$page_template = $page_temp_arr[0] . $content_code . "\n\n<!--content_code-->\n" . $page_temp_arr[1];
		unset($page_temp_arr);
	}
		
	//If plugin is selected, then insert header code snippet after <!--header_code--> comment. (not to be confused with head)
	if (($plugin != "-not selected-") && ($header_code != ""))
	{
		$page_temp_arr = explode("<!--header_code-->", $page_template, 2);
		$page_template = $page_temp_arr[0] . $header_code . "\n\n<!--header_code-->\n" . $page_temp_arr[1];
		unset($page_temp_arr);
	}
		
	//If plugin is selected, then insert footer code snippet after <!--footer_code--> comment.
	if (($plugin != "-not selected-") && ($footer_code != ""))
	{
		$page_temp_arr = explode("<!--footer_code-->", $page_template, 2);
		$page_template = $page_temp_arr[0] . $footer_code . "\n\n<!--footer_code-->\n" . $page_temp_arr[1];
		unset($page_temp_arr);
	}

	//If plugin is selected, then insert top code snippet after <!--top_code--> comment.
	if (($plugin != "-not selected-") && ($top_code != ""))
	{
		if (strpos($page_template, "<!--top_code-->") > 0)
		{
			$page_temp_arr = explode("<!--top_code-->", $page_template, 2);
			$page_template = $page_temp_arr[0] . $top_code . "\n\n<!--top_code-->\n" . $page_temp_arr[1];
			unset($page_temp_arr);
		}
	}
	
	//If plugin is selected, then insert left code snippet after <!--left_code--> comment.
	if (($plugin != "-not selected-") && ($left_code != ""))
	{
		if (strpos($page_template, "<!--left_code-->") > 0)
		{
			$page_temp_arr = explode("<!--left_code-->", $page_template, 2);
			$page_template = $page_temp_arr[0] . $left_code . "\n\n<!--left_code-->\n" . $page_temp_arr[1];
			unset($page_temp_arr);
		}
	}
	
	//If plugin is selected, then insert right code snippet after <!--right_code--> comment.
	if (($plugin != "-not selected-") && ($right_code != ""))
	{
		if (strpos($page_template, "<!--right_code-->") > 0)
		{
			$page_temp_arr = explode("<!--right_code-->", $page_template, 2);
			$page_template = $page_temp_arr[0] . $right_code . "\n\n<!--right_code-->\n" . $page_temp_arr[1];
			unset($page_temp_arr);
		}
	}
	
	//If plugin is selected, then insert bottom code snippet after <!--bottom_code--> comment.
	if (($plugin != "-not selected-") && ($bottom_code != ""))
	{
		if (strpos($page_template, "<!--bottom_code-->") > 0)
		{
			$page_temp_arr = explode("<!--bottom_code-->", $page_template, 2);
			$page_template = $page_temp_arr[0] . $bottom_code . "\n\n<!--bottom_code-->\n" . $page_temp_arr[1];
			unset($page_temp_arr);
		}
	}

	//If plugin is selected, then replace HTML head holder with head code snippet.
	if (($plugin != "-not selected-") && (isset($head_html)) && ($head_html != ""))
	{
		// Get head content from main head.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT head_content FROM " . BWB_TABLE_PREFIX . "head WHERE head_name = 'head'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$head_content = $row["head_content"];
		
		// Combine HTML (Javascript) code with default head content.
		$head_content = $head_content . "\n\n\n" . $head_html;
		$head_content = addslashes(stripslashes($head_content));
		
		// Check to see if head record alread exists.
		$head_name = "head_" . $page_name;
		$query = "SELECT head_name FROM " . BWB_TABLE_PREFIX . "head WHERE head_name = '$head_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$head_name .= time();
		
		// Insert new head into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "head (head_name, head_content, `revised`, plugins) VALUES ('" . $head_name . "', '" . $head_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to head content in template.
		$head_str = "head_name='" . $head_name . "'";
		$page_template = str_replace("head_name='head'", $head_str, $page_template);
	}
	
	//If plugin is selected, then replace HTML header holder with header HTML code snippet.
	if (($plugin != "-not selected-") && (isset($header_html)) && ($header_html != ""))
	{	
		// Get header content from main header.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'header'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$header_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default header content.
		$header_content = $header_content . "\n\n\n" . $header_html;
		$header_content = addslashes(stripslashes($header_content));

		// Check to see if head record alread exists.
		$header_name = "header_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$header_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$header_name .= time();

		// Insert new header into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $header_name . "', '" . $header_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to header content in template.
		$header_str = "page_name='" . $header_name . "'";
		$page_template = str_replace("page_name='header'", $header_str, $page_template);
	}

	//If plugin is selected, then replace HTML footer holder with footer HTML code snippet.
	if (($plugin != "-not selected-") && (isset($footer_html)) && ($footer_html != ""))
	{
		// Get footer content from main footer.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'footer'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$footer_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default footer content.
		$footer_content = $footer_content . "\n\n\n" . $footer_html;
		$footer_content = addslashes(stripslashes($footer_content));
		
		// Check to see if head record alread exists.
		$footer_name = "footer_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$footer_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$footer_name .= time();
		
		// Insert new footer into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $footer_name . "', '" . $footer_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to footer content in template.
		$footer_str = "page_name='" . $footer_name . "'";
		$page_template = str_replace("page_name='footer'", $footer_str, $page_template);
	}

	//If plugin is selected, then append HTML code snippet to top.
	if (($plugin != "-not selected-") && (isset($top_html)) && ($top_html != ""))
	{
		// Get footer content from main footer.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'top'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$top_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default top content.
		$top_content = $top_content . "\n\n\n" . $top_html;
		$top_content = addslashes(stripslashes($top_content));
		
		// Check to see if head record alread exists.
		$top_name = "top_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$top_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$top_name .= time();
		
		// Insert new top into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $top_name . "', '" . $top_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to top content in template.
		$top_str = "page_name='" . $top_name . "'";
		$page_template = str_replace("page_name='top'", $top_str, $page_template);
	}
	
	//If plugin is selected, then append HTML code snippet to left.
	if (($plugin != "-not selected-") && (isset($left_html)) && ($left_html != ""))
	{
		// Get footer content from main footer.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'left'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$left_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default left content.
		$left_content = $left_content . "\n\n\n" . $left_html;
		$left_content = addslashes(stripslashes($left_content));
		
		// Check to see if head record alread exists.
		$left_name = "left_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$left_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$left_name .= time();
		
		// Insert new top into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $left_name . "', '" . $left_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to top content in template.
		$left_str = "page_name='" . $left_name . "'";
		$page_template = str_replace("page_name='left'", $left_str, $page_template);
	}
	
	//If plugin is selected, then append HTML code snippet to right.
	if (($plugin != "-not selected-") && (isset($right_html)) && ($right_html != ""))
	{
		// Get footer content from main footer.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'right'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$right_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default right content.
		$right_content = $right_content . "\n\n\n" . $right_html;
		$right_content = addslashes(stripslashes($right_content));
		
		// Check to see if head record alread exists.
		$right_name = "right_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$right_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$right_name .= time();
		
		// Insert new top into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $right_name . "', '" . $right_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to top content in template.
		$right_str = "page_name='" . $right_name . "'";
		$page_template = str_replace("page_name='right'", $right_str, $page_template);
	}
	
	//If plugin is selected, then append HTML code snippet to bottom.
	if (($plugin != "-not selected-") && (isset($bottom_html)) && ($bottom_html != ""))
	{
		// Get footer content from main footer.  Most likely that we want this as default.  Can edit later.
		$query = "SELECT page_content FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = 'bottom'";
		$result = $bwb_dbh->query($query);
		$row = $result->fetch(PDO::FETCH_ASSOC);
		$bottom_content = $row["page_content"];
		
		// Combine HTML (Javascript) code with default bottom content.
		$bottom_content = $bottom_content . "\n\n\n" . $bottom_html;
		$bottom_content = addslashes(stripslashes($bottom_content));
		
		// Check to see if head record alread exists.
		$bottom_name = "bottom_" . $page_name;
		$query = "SELECT page_name FROM " . BWB_TABLE_PREFIX . "page_data_special WHERE page_name = '$bottom_name'";
		$result = $bwb_dbh->query($query);
		$row_cnt = $result->rowCount();
		if ($row_cnt > 0)
			$bottom_name .= time();
		
		// Insert new top into table.
		$query = "INSERT INTO " . BWB_TABLE_PREFIX . "page_data_special (page_name, page_content, `revised`, plugins) VALUES ('" . $bottom_name . "', '" . $bottom_content . "', '" . $today . "', '" . $plugin_id . "')";
		$cnt = $bwb_dbh->exec($query);
		
		// Replace reference to top content in template.
		$bottom_str = "page_name='" . $bottom_name . "'";
		$page_template = str_replace("page_name='bottom'", $bottom_str, $page_template);
	}
			
	// Create file.
	$fh = fopen($file_name, 'xb') or die("Can't create $file_name: $php_errormsg");
	$result = (fwrite($fh, $page_template));
	fclose($fh) or die($php_errormsg);
	@chmod($file_name, 0755);
	
	// Create plugin tables if plugin selected and table not existing.
	if (($plugin != "-not selected-") && ($deployed != 1))
	{
		if (isset($style_sheet) && ($style_sheet != ""))
		{
			$query = "SELECT * FROM " . BWB_TABLE_PREFIX . "style_sheets WHERE `name`='" . $style_sheet . "'";
			$result = $bwb_dbh->query($query);
			if ($result->rowCount() < 1)
			{
				$query = "SELECT MAX(sort_order) AS sort_order FROM " . BWB_TABLE_PREFIX . "style_sheets";
				$result = $bwb_dbh->query($query);
				$row = $result->fetch(PDO::FETCH_ASSOC);
				$sort_order = $row['sort_order'] + 10;
				
				$query = "INSERT INTO " . BWB_TABLE_PREFIX . "style_sheets SET `name`='" . $style_sheet . "', `description`='" . $style_sheet_description . "', `sort_order`=" . $sort_order;
				$cnt = $bwb_dbh->exec($query);
			}
			
			$query = "SELECT * FROM " . BWB_TABLE_PREFIX . "plugins WHERE `style_sheet`='" . $style_sheet . "' AND `deployed` = 1";
			$result = $bwb_dbh->query($query);
			if ($result->rowCount() < 1)
			{
				if (isset($class_sql) && ($class_sql != ""))
				{
					$class_table = $style_sheet . "_classes";
					$result = copy_table_structure($class_table, BWB_TABLE_PREFIX, $bwb_dbh, $bwb_database);
					$result = RunSQL($class_sql, $bwb_dbh, BWB_TABLE_PREFIX, false, false, UPLOAD_TEMPLATE_ROWS_AFFECTED_MSG);
				}
				
				if (isset($css_sql) && ($css_sql != ""))
				{
					$site_css_table = $style_sheet . "_css";
					$result = copy_table_structure($site_css_table, BWB_TABLE_PREFIX, $bwb_dbh, $bwb_database);
					$result = RunSQL($css_sql, $bwb_dbh, BWB_TABLE_PREFIX, false, false, UPLOAD_TEMPLATE_ROWS_AFFECTED_MSG);
					
					include ("build_css_string.php");
					////////////////////////////////////////////////////////
					/// Write menu items to menu.css file /////////////
					//Test to see if file already exists.
					if (BWB_BASE_DIR == '')
						$userfiles = '';
					else
						$userfiles = "/" . BWB_BASE_DIR;
						
					$css_file = $style_sheet . ".css";
					$file_name = $document_root . $userfiles . "/" . BWB_CSS_DIR . "/" . $css_file;
						
					if (file_exists($file_name))
					{
						$bkup_file_name = $file_name . time();
						if (!rename($file_name, $bkup_file_name))
							echo EDIT_CSS_COULD_NOT_RENAME_1_ERR . " $file_name " . EDIT_CSS_COULD_NOT_RENAME_2_ERR . " $bkup_file_name.<br>";
						@chmod($bkup_file_name, 0644);
					}
					
					// Create file.
					$fh = fopen($file_name, 'x') or die(EDIT_CSS_CANT_CREATE_ERR . " $file_name: $php_errormsg");
					$result = (fputs($fh, $css_string));
					fclose($fh) or die($php_errormsg);
					@chmod($file_name, 0644);
				}
			}
		}
	
		if (isset($plugin_sql) && ($plugin_sql != ""))
		{
			$result = RunSQL($plugin_sql, $bwb_dbh, BWB_TABLE_PREFIX, false, false, UPLOAD_TEMPLATE_ROWS_AFFECTED_MSG);
		}
	
		$query = "UPDATE " . BWB_TABLE_PREFIX . "plugins SET `deployed`=1 WHERE `id`=$plugin";
		$cnt = $bwb_dbh->exec($query);
	}	
	
	//Go to edit page.
	$edit_page = "edit_page.php?page_name=$page_name&mode=$mode";
	if (($plugin != "-not selected-") && ($deployed != 1))
		$edit_page .= "&refresh_buttons=1";
	try	{
		header("Location: $edit_page");
	} catch (Exception $e) {
		echo $e->getMessage();
	}
	
?>